#ifndef KINEMATICSINTERFACE_H
#define KINEMATICSINTERFACE_H

#include <stdint.h>
#include <QtPlugin>

class KinematicsInterface
{
public:
    virtual ~KinematicsInterface() {}
    virtual void MKinematics(int64_t * input, int64_t * output, uint32_t naxes) = 0;
    virtual void setInputRatios(double * ratio, uint32_t naxes) = 0;
    virtual void setOutputRatios(double * ratio, uint32_t naxes) = 0;
    virtual void setParameters(uint32_t addr, double param) = 0;

};

#define Kinematics_Interface_iid "pv-automation.myCNC.ET15.R1.KinematicsInterface"

Q_DECLARE_INTERFACE(KinematicsInterface, Kinematics_Interface_iid)


#endif // KINEMATICSINTERFACE_H
