#ifndef KINEMATICSPLUGIN_H
#define KINEMATICSPLUGIN_H

#include "kinematicsinterface.h"

#include <QObject>
#include <QtPlugin>


class KinematicsPlugin : public QObject, KinematicsInterface
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID Kinematics_Interface_iid FILE "kinematicsplugin.json")
    Q_INTERFACES(KinematicsInterface)

public:
    KinematicsPlugin(QObject *parent = 0);
    void MKinematics(int64_t * input, int64_t * output, uint32_t naxes);
    void setInputRatios(double * ratio, uint32_t naxes);
    void setOutputRatios(double * ratio, uint32_t naxes);
    void setParameters(uint32_t addr, double param);


protected:
    double InputRatio[32];
    double OutputRatio[32];
    double R1,R2;

};

#endif // KINEMATICSPLUGIN_H
